﻿using HaBookCms.AzureCosmos.CosmosDB.Implements;
using HaBookCms.AzureCosmos.CosmosDB.Interfaces;
using HaBookCms.ServiceOptions.Options;
using Microsoft.Extensions.DependencyInjection;
using System;
using System.Collections.Generic;
using System.Text;

namespace HaBookCms.AzureCosmos.ServiceExtension
{
    public static class AzureCosmosDBServiceCollectionExtensions
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="services"></param>
        /// <returns></returns>
        private static AzureCosmosDBServiceBuilder AddCosmosDBServerBuilder(this IServiceCollection services)
        {
            return new AzureCosmosDBServiceBuilder(services);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="services"></param>
        /// <returns></returns>
        public static AzureCosmosDBServiceBuilder AddAzureCosmosDB(this IServiceCollection services)
        {
            var builder = services.AddCosmosDBServerBuilder();
            services.AddSingleton<IAzureCosmosDBRepository, AzureCosmosDBRepository>();
            return builder;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="builder"></param>
        /// <param name="_connectionString"></param>
        /// <returns></returns>
        public static AzureCosmosDBServiceBuilder AddCosmosDBConnection(this AzureCosmosDBServiceBuilder builder,  AzureCosmosDBOptions  databaseOptions)
        {
            //AzureCosmosDBOptions databaseOptions = new AzureCosmosDBOptions();
            //databaseOptions.ConnectionString = _connectionString;
            //databaseOptions.ConnectionKey = _connectionKey;
            builder.Services.AddSingleton(databaseOptions);
            return builder;
        }
    }

}

