const Config = require('webpack-chain');
const config = new Config();
module.exports = {
    baseUrl: '/',
    outputDir: './wwwroot',
    lintOnSave: true,
    runtimeCompiler: true, 
    devServer: {
        open: process.platform === 'darwin',
        host: '0.0.0.0',
        port: 8080,
        https: false,
        hotOnly: false,
        proxy: null, // string | Object
        before: app => { }
    },
    pages: {
        index: {
            entry: './ContestApp/src/main.js'
        }
    },
    chainWebpack: config => {
        config
            // Interact with entry points
            .entry('index')
            .add('./ContestApp/src/main.js')
            .end()
            // Modify output settings
            .output
            .filename('main.js');
        
        // Create named rules which can be modified later
        
    }
}