﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Text;

namespace HaBookCms.Core.Models.Contest
{
    /// <summary>
    /// 申报活动
    /// </summary>
    public class BaseActivty
    {
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }
        /// <summary>
        /// Desc:活动名称
        /// </summary>   
        public string Title { get; set; }
        /// <summary>
        /// Desc:流程标识
        /// </summary>  
        public Model[] Models { get; set; }
        /// <summary>
        /// Desc:活动组件
        /// </summary>  
        public Parts[] Children { get; set; }
        /// <summary>
        /// Desc:活动简介
        /// </summary>  
        public string Introduce { get; set; }
        /// <summary>
        /// Desc:活动链接
        /// </summary>  
        public string ActivityLink { get; set; }
        /// <summary>
        /// Desc:活动状态
        /// </summary>  
        public string state { get; set; }
        public override string ToString()
        {
            return JsonConvert.SerializeObject(this);
        }

        public class Model {
            /// <summary>
            /// Desc:模块唯一标识
            /// </summary>  
            public string ModelId { get; set; }
            /// <summary>
            /// Desc:模块名称
            /// </summary>  
            public string ModelName { get; set; }
            /// <summary>
            /// Desc:模块时间段
            /// </summary>  
            public string ModelStartTime { get; set; }
            public string ModelEndTime { get; set; }
        }

        public class Parts
        {
            /// <summary>
            /// Desc:组件唯一标识
            /// </summary>  
            public string PartId { get; set; }
            /// <summary>
            /// Desc:组件名称
            /// </summary>  
            public string PartlLabel { get; set; }
            /// <summary>
            /// Desc:组件关联字段
            /// </summary>  
            public string PartFiled { get; set; }
            /// <summary>
            /// Desc:组件类型
            /// </summary>  
            public string PartType { get; set; }
        }
    }
}
