﻿using System;
using System.Collections.Generic;
using System.Text;

namespace HaBookCms.Core.Models.System
{
    /// <summary>
    /// 系统角色信息
    /// </summary>
    public class SysRole
    {
        public SysRole()
        {
        }
        public SysRole(string name)
        {
            Name = name;
            Description = "";
            Sort = 1;
            Status = 1;
            CreateTime = DateTime.Now.Ticks;
        }
        /// <summary>
        /// 是否超级管理员
        /// </summary>           
        public bool IsSystem { get; set; }
        /// <summary>
        /// 角色编号
        /// </summary>           
        public string Code { get; set; }
        /// <summary>
        /// ID
        /// </summary>           
        public string Guid { get; set; }
        /// <summary>
        ///获取或设置是否禁用，逻辑上的删除，非物理删除
        /// </summary>
        public int  Status { get; set; }
        /// <summary>
        /// 角色名
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// 角色标题
        /// </summary>
        public string Title { get; set; }
        /// <summary>
        ///描述
        /// </summary>
        public string Description { get; set; }
        /// <summary>
        ///排序
        /// </summary>
        public int Sort { get; set; }
        /// <summary>
        /// 创建ID
        /// </summary>
        public string CreateTeamModelId { get; set; }
        /// <summary>
        /// 创建者
        /// </summary>
        public string CreateNickName { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        public long CreateTime { get; set; }
       
    }
}
